
from scipy import *
from pylab import *
import time
import sys

def set_circle(arr,value,center,r):
   for x in range(-r,r): 
      for y in range(-r,r):
	 if (x**2+y**2) > r**2: continue
	 arr[center[0]+x,center[1]+y] = value
   return

def circle_mask(size,center,r):
   arr = zeros(size)
   set_circle(arr,1.0,center,r)
   return arr

def set_square(arr,value,center,r):
   for x in range(-r,r): 
      for y in range(-r,r):
	 arr[center[0]+x,center[1]+y] = value
   return




 
def make_anis_filter1(sigsq,nx,ny,anis): 
   inv = 1/(2.0*sigsq)
   filtery = matrix(array([(exp(-(x**2*(1+anis*x**2))*inv) + exp(-((ny-x)**2*(1+anis*(ny-x)**2)*inv))) for x in range(ny)],dtype=float))
   normy = sum(filtery)
   filtery = filtery/normy

   filterx = matrix(array([(exp(-(x**2*(1+anis*x**2))*inv) + exp(-((nx-x)**2*(1+anis*(nx-x)**2)*inv))) for x in range(nx)],dtype=float))
   normx = sum(filterx)
   filtery = filtery/normx
   filterx = transpose(filterx)
   return fft2(array(filterx*filtery))

def make_anis_filter(sigsq,nx,ny,anis): 
   filter = zeros((nx,ny))
   filter1 = zeros((nx,ny))
   inv = 1/(2.0*sigsq)
   for x in range(nx):
      for y in range(ny):
	 filter1[x,y] = exp(-inv*(x**2+y**2 + 0.25*anis*((x-y)**4 + (x+y)**4)))
   filter = filter1+0# the zero makes this a new reference

   for x in range(1,nx):
      for y in range(0,ny):
            filter[x,y] += filter1[nx-x,y] 

   for x in range(0,nx):
      for y in range(1,ny):
            filter[x,y] += filter1[x,ny-y] 

   for x in range(1,nx):
      for y in range(1,ny):
            filter[x,y] += filter1[nx-x,ny-y] 

   norm = sum(filter)
   filter = filter/norm
   return fft2(filter)
   

def make_gauss_filter(sigsq,nx,ny): 
   return make_anis_filter(sigsq,nx,ny,0)
  
  
nx = 128
ny = 128
dt = 0.01
Dphi = 8




ion()

filter_phi = make_anis_filter1(2*Dphi*dt,nx,ny,0.0)

dims = (nx,ny)

phi = zeros(dims,dtype=float)

phi += 0.01*standard_normal(dims)


for k in range(20000):

   phik = fft2(phi)
   phik = phik*filter_phi
   phi = real(ifft2(phik))

   #V = (phi^2-1)^2 + T*phi

   phi += -dt*phi*(phi*phi-1)

   if (k%100 == 0): 
      imshow(phi)
      #plot(phi[:,ny/2])
      #cla()
      show()
      #if (phi[nx/5,ny/5] > 0.2): break


      show()

